﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO;

namespace feherje
{
    class Program
    {
        class Aminosav
        {
            public string Azon { get; set; }
            public char Jel { get; set; }
            public int C { get; set; }
            public int H { get; set; }
            public int O { get; set; }
            public int N { get; set; }
            public int S { get; set; }
            #region 2. feladat - molekulatömeg
            public int M
            {
                get
                {
                    return C * 12 + H * 1 + O * 16 + N * 14 + S * 32;
                }
            }
            #endregion;
            public Aminosav(string _azon, char _jel, int _c, int _h, int _o, int _n, int _s)
            {
                Azon = _azon;
                Jel = _jel;
                C = _c;
                H = _h;
                O = _o;
                N = _n;
                S = _s;

            }
        }

        static void Main(string[] args)
        {
            StreamWriter ki = new StreamWriter("eredmeny.txt");
            #region 1. feladat - aminosavak beolvasása
            StreamReader be = new StreamReader("aminosav.txt");
            List<Aminosav> savak = new List<Aminosav>();
            while (!be.EndOfStream)
            {
                Aminosav amin = new Aminosav((string)be.ReadLine(), Convert.ToChar(be.ReadLine()[0]), Convert.ToInt32(be.ReadLine()), Convert.ToInt32(be.ReadLine()), Convert.ToInt32(be.ReadLine()), Convert.ToInt32(be.ReadLine()), Convert.ToInt32(be.ReadLine()));
                savak.Add(amin);
            }
            be.Close();
            #endregion;
            #region 3. feladat - rendezés
            Console.WriteLine("3. feladat");
            ki.WriteLine("3. feladat");
            savak.Sort(delegate(Aminosav a1, Aminosav a2) { return a1.M.CompareTo(a2.M); });
            foreach (Aminosav sav in savak)
            {
                Console.WriteLine("{0} {1}", sav.Azon, sav.M);
                ki.WriteLine("{0} {1}", sav.Azon, sav.M);
            }
            #endregion;
            #region bsa lánc beolvasása
            List<char> fehérje = new List<char>();
            be = File.OpenText("bsa.txt");
            while (!be.EndOfStream)
            {
                fehérje.Add(Convert.ToChar(be.ReadLine()[0]));
            }
            be.Close();
            #endregion;
            #region 4. feladat - bsa összegképlet
            Console.WriteLine("4. feladat");
            ki.WriteLine("4. feladat");
            Aminosav bsa = new Aminosav("bsa", ' ', 0, 0, 0, 0, 0); //teljesen logikátlan, de az adatszerkezet jó hozzá
            foreach (char jel in fehérje)
            {
                foreach (Aminosav amin in savak)
                {
                    if (amin.Jel == jel)
                    {
                        bsa.C += amin.C;
                        bsa.H += amin.H - 2;
                        bsa.O += amin.O - 1;
                        bsa.N += amin.N;
                        bsa.S += amin.S;
                    }
                }
            }
            bsa.H += 2;
            bsa.O++;
            Console.WriteLine("C {0} H {1} O {2} N {3} S {4}", bsa.C, bsa.H, bsa.O, bsa.N, bsa.S);
            ki.WriteLine("C {0} H {1} O {2} N {3} S {4}", bsa.C, bsa.H, bsa.O, bsa.N, bsa.S);
            #endregion;
            #region 5. feladat - kimotripszin hasítása
            Console.WriteLine("5. feladat");
            ki.WriteLine("5. feladat");
            int kezd = 1;
            int hossz = 0;
            int maxkezd = 0;
            int maxhossz = 0;
            foreach (char jel in fehérje)
            {
                hossz++;
                if ((jel == 'Y') || (jel == 'W') || (jel == 'F'))
                {
                    if (hossz > maxhossz)
                    {
                        maxhossz = hossz;
                        maxkezd = kezd;
                    }
                    kezd += hossz;
                    hossz = 0;
                }
            }
            Console.WriteLine("a kezdet helye: {0}\ta végének helye: {1}\thossza: {2}", maxkezd, maxkezd + maxhossz - 1, maxhossz);
            #endregion;
            #region 6. feladat - Cisztein db;
            Console.WriteLine("6. feladat");
            ki.WriteLine("6. feladat");
            string lánc = "";
            foreach (char jel in fehérje)
            {
                lánc = lánc + Convert.ToString(jel);
            }
            int helya = (lánc.IndexOf("RA") == -1) ? lánc.Length : lánc.IndexOf("RA");
            int helyb = (lánc.IndexOf("RB") == -1) ? lánc.Length : lánc.IndexOf("RV");
            int hely = Math.Min(helya, helyb) + 1;
            char[] eleje = new char[hely];
            lánc.CopyTo(0, eleje, 0, hely);
            int db = 0;
            foreach (char jel in eleje)
            {
                if (jel == 'C')
                {
                    db++;
                }
            }
            Console.WriteLine("az első {0} hosszú hasított láncdarabban {1} Cisztein található", hely, db);
            #endregion
            ki.Close();
            Console.ReadLine();
        }
    }
}
